/*
 * Copyright (c) 2003 Atmark Techno, Inc.  All Rights Reserved.
 */

#include <target/buffer.h>
#include <target/crc.h>
#include <target/io.h>
#include "frob.h"
#include "flash.h"
#include "memmap.h"
#include "linux.h"
#include "bootmode.h"
#include "test.h"

static const command_t *commands[] = {
	&help_command,
	&frob_command,
	&jump_command,
	&upload_command,
	&version_command,
        &memmap_command,
        &flash_erase_command,
        &flash_program_command,
	&download_command,
        &linux_command,
        &boot_command,
	0
};

ABBR(boot_command, 'b')
ABBR(help_command, '?')
ABBR(frob_command, 'f')
ABBR(version_command, 'V')
ABBR(test_command, 0x02)

static const abbrev_t *abbrevs[] = {
	&boot_command_abbrev,
	&help_command_abbrev,
	&frob_command_abbrev,
	&version_command_abbrev,
	&test_command_abbrev,
	0
};

int hmain(void)
{
	command_list_t command_list = { commands, abbrevs, "hermit", 0 };

	flash_init();
        if (is_mfgi_hi())
                (*boot_command.func)(0, 0);

	/* startup stuff: print version string */
	(*version_command.func)(0, 0);
	init_crc32();

	do_command_loop(&command_list);
	for (;;);
}

