/*
 * Copyright (c) 2003 Atmark Techno, Inc.  All Rights Reserved.
 */

#ifndef _HERMIT_AJ_MEMREGIONS_H
#define _HERMIT_AJ_MEMREGIONS_H

#define FLASH_START       (0x02000000)
#define FLASH_SIZE_2M     (0x00200000)
#define FLASH_SIZE_4M     (0x00400000)
#define FLASH_SIZE        (get_flash_size())

#define RESERVED_START    (FLASH_START)
#define RESERVED_SIZE     (0x00008000)

#define HERMIT_START      (RESERVED_START + RESERVED_SIZE)
#define HERMIT_SIZE       (0x00008000)

#define USER_START        (HERMIT_START + HERMIT_SIZE)
#define USER_SIZE_2M      (0x001F0000)
#define USER_SIZE_4M      (0x003F0000)
#define USER_SIZE         (get_user_size())

#define DRAM_START        (0x00000000)
#define DRAM_SIZE         (0x00800000)

#define USER_BLOCKS_2M    ("31x64K")
#define USER_BLOCKS_4M    ("63x64K")
#define user_blocking     (get_user_blocking())

#ifndef __ASSEMBLY__
unsigned int get_flash_size(void);
unsigned int get_user_size(void);
char *get_user_blocking(void);
#endif

#endif /* _HERMIT_AJ_MEMREGIONS_H */

