/*
 * Copyright (c) 2000 Blue Mug, Inc.  All Rights Reserved.
 * Copyright (c) 2003-2004 Atmark Techno, Inc. All Rights Reserved.
 */

#include <target/io.h>
#include "memmap.h"

#define PRINT_FLASH_MEMMAP(name, NAME)                                  \
        hprintf("%p:%p FLA " #name " bf:8K bl:%s\n",                     \
                NAME ## _START, NAME ## _END, NAME ## _BLOCKING)
#define PRINT_RAM_MEMMAP(name, NAME)           \
        hprintf("%p:%p RAM " #name "\n",       \
                NAME ## _START, NAME ## _END)

static int memmap_cmdfunc(int argc, char *argv[])
{
        PRINT_FLASH_MEMMAP(fpga, FPGA);
        PRINT_FLASH_MEMMAP(bootloader, BOOTLOADER);
        PRINT_FLASH_MEMMAP(image, IMAGE);
        PRINT_FLASH_MEMMAP(kernel, KERNEL);
        PRINT_FLASH_MEMMAP(user, USER);
        PRINT_FLASH_MEMMAP(config, CONFIG);
        PRINT_RAM_MEMMAP(dram, DRAM);

	return 0;
}

const command_t memmap_command =
	{ "memmap", 0, "output memory map", &memmap_cmdfunc };

